
LoadFont (0, "Arial", 20)              ; Load Arial Font, Size 20

If OpenWindow(0, 100, 150, 350, 260, "VAG-Com to WBH-Diag Labelconverter V1.01")

  ;
  ; Create the menu. The indent is very important here for a good lisibility
  ;

  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
      MenuItem( 1, "&Load...")
      MenuItem( 2, "&Convert")      
      MenuBar()
      MenuItem( 3, "&Quit")    
      
    MenuTitle("?")
      MenuItem(4, "About")

  EndIf
  
  DisableMenuItem(0, 2, 1)
    
  ;
  ; This is the 'event loop'. All the user actions are processed here.
  ; It's very easy to understand: when an action occurs, the EventID
  ; isn't 0 and we just have to see what have happened...
  ;
  
  Repeat

    Select WaitWindowEvent()

      Case #PB_Event_Menu

        Select EventMenu()  ; To see which menu has been selected

          Case 1 ; Load
          
            Pattern$ = "VAG-Com labelfile (*.lbl)|*.lbl"
            Pattern = 0    ; use the first of the three possible patterns as standard
            File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, Pattern)
            If File$
              DisableMenuItem(0, 2, 0)
            EndIf
            
          Case 2 ; Convert
            Gosub Convert
            
          Case 3 ; Quit
            Quit = 1

          Case 4 ; About
            MessageRequester("About", "VAG-Com to WBH-Diag Labelconverter "+Chr(10)+Chr(10)+"                        V1.01"+Chr(10)+Chr(10)+"                    copyright by"+Chr(10)+Chr(10)+"                         Beard", 0)
            
          Default
            MessageRequester("Info", "MenuItem: "+Str(EventMenu()), 0)

        EndSelect

      Case #PB_Event_Repaint
        Gosub SomeGraphics                ; we will repaint our graphic


      Case #PB_Event_CloseWindow
        Quit = 1

    EndSelect

  Until Quit = 1

EndIf

End 


SomeGraphics:

  If StartDrawing(WindowOutput(0))            ;
    DrawingMode(1)                          ; Transparent TextBackground  
    DrawingFont(FontID(0))                 ; Use the 'Arial' font    
    
    DrawText(25,60, "VAG-Com to WBH-Diag")      ; Print our text
    DrawText(70,140, "Label converter")      ; Print our text
    
    StopDrawing()                           ; This is absolutely needed when the drawing operations are 
  EndIf                                    ; finished !!! Never forget it !
Return 





Convert:  
  
  If ReadFile(0, File$)        ; wenn die Datei geffnet werden konnte, setzen wir fort...
  
    WBHName$ = GetFilePart(File$)
    WBHName$ = ReplaceString(WBHName$, "-", "")         ; entfernt die Bindestriche
    WBHName$ = ReplaceString(WBHName$, ".lbl", ".ini")  ; ersetzt .lbl mit .ini

    If CreateFile(1, GetPathPart(File$)+WBHName$)
    
      CrLf$ = Chr(13) + Chr(10)
    
      WriteString(1, ";" + CrLf$)
      WriteString(1, "; WBH-Diag labelfile" + CrLf$)
      WriteString(1, ";" + CrLf$)
      WriteString(1, "; created with VAGC2WBH V1.01" + CrLf$)
      WriteString(1, ";" + CrLf$)
      WriteString(1, CrLf$)
      WriteString(1, "[Info]" + CrLf$ + CrLf$)
        
      OldGroupNo = 0
      OldGroupNoPart = 4
      GroupFlag = 0
      RawFlag = 0
      CodingFlag = 0
      While Eof(0) = 0            ; sich wiederholende Schleife bis das Ende der Datei ("end of file") erreicht ist
       Line$ = ReadString(0)
       If Left(Line$, 1) <> ";"
        If Left(Line$, 1) < "A"
         
         Pos = FindString(Line$, ",", 1)
         GroupNo = Val(Left(Line$, Pos))
         
         If GroupNo <> 0          
           
          If GroupFlag = 0
           GroupFlag = 1
           WriteString(1, CrLf$ + "[Groups]" + CrLf$)
          EndIf
          
          

          If GroupNo <> OldGroupNo
           
           For k = OldGroupNoPart + 1 To 4
            WriteString(1, "G" + Str(OldGroupNo) + "." + Str(k) + "=" + CrLf$)
           Next
           
           OldGroupNo = GroupNo
           WriteString(1, CrLf$)
           
           OldGroupNoPart = 0
           
          EndIf

                           
          GroupNoPart = Val(Mid(Line$, Pos + 1))
         
          If GroupNoPart <> 0
           
           For k = OldGroupNoPart + 1 To GroupNoPart - 1
            WriteString(1, "G" + Str(GroupNo) + "." + Str(k) + "=" + CrLf$)
           Next
           
           OldGroupNoPart = GroupNoPart
           
           Pos2 = FindString(Line$, ",", Pos + 1)
           Pos3 = FindString(Line$, ",", Pos2 + 1)
           If Pos3 <> 0
            GroupNoPartText$ = Mid(Line$, Pos2 + 1, Pos3 - Pos2 - 1)
            If Right(GroupNoPartText$, 1) = "-"
             GroupNoPartText$ = Left(GroupNoPartText$, Len(GroupNoPartText$) - 1)
            Else
             If Mid(Line$, Pos3 + 1, 1) <> ","
              GroupNoPartText$ = GroupNoPartText$ + " "
             EndIf
            EndIf
            Pos4 = FindString(Line$, ",", Pos3 + 1)
            If Pos4 <> 0
             GroupNoPartText$ = GroupNoPartText$ + Mid(Line$, Pos3 + 1, Pos4 - Pos3 -1)
            Else
             GroupNoPartText$ = GroupNoPartText$ + Mid(Line$, Pos3 + 1)
            EndIf
           Else
            GroupNoPartText$ = Mid(Line$, Pos2 + 1)
           EndIf
           
           WriteString(1, "G" + Str(GroupNo) + "." + Str(GroupNoPart) + "=" + GroupNoPartText$ + CrLf$)
          EndIf
          
         Else     ; Group 0 means RAW data
         
          If RawFlag = 0
		       RawFlag = 1;
		       WriteString(1, CrLf$ + "[Raw]" + CrLf$ + CrLf$)
		      EndIf
		      
		      GroupNoPart = Val(Mid(Line$, Pos + 1))
         
          If GroupNoPart <> 0
           Pos2 = FindString(Line$, ",", Pos + 1)
           Pos3 = FindString(Line$, ",", Pos2 + 1)
           If Pos3 <> 0
            GroupNoPartText$ = Mid(Line$, Pos2 + 1, Pos3 - Pos2 - 1) 
           Else
            GroupNoPartText$ = Mid(Line$, Pos2 + 1)
           EndIf
          
           WriteString(1, "raw" + Str(GroupNoPart) + "=" + GroupNoPartText$ + CrLf$)
          EndIf
		      
		     EndIf
		      		      
		    Else     ; not a digit at start
		    
		     If Left(Line$, 1) = "C"
		     
		      If CodingFlag = 0
		       CodingFlag = 1;
		       WriteString(1, CrLf$ + "[Coding]" + CrLf$ + CrLf$)
		      EndIf
		 
		      GroupNo = Val(Mid(Line$, 2))
		      
		      If GroupNo > 0
		      
		       Pos1 = FindString(Line$, ",", 1)
		       GroupNoPartText$ = Mid(Line$, Pos1 + 1)
		      
		       WriteString(1, "C" + Str(GroupNo) + "=" + GroupNoPartText$ + CrLf$)
		      
		      EndIf
		      
		     EndIf
		    
        EndIf        
       
       EndIf      ; a comment
      Wend
      
      ; no informations available in VAG-Com labelfiles
      ; so write only the headline
      WriteString(1, CrLf$ + ";" + CrLf$);
      WriteString(1, "; no informations about adaptions available" + CrLf$);
      WriteString(1, ";" + CrLf$ + CrLf$);
      WriteString(1, "[Adaption]" + CrLf$ + CrLf$);
      
      CloseFile(1)
     Else
      MessageRequester("Information","Konnte "+WBHName$+" nicht anlegen!")
     EndIf
    CloseFile(0)                    ; schlieen der zuvor geffneten Datei
  Else
    MessageRequester("Information","Konnte "+GetFilePart(File$)+" nicht ffnen!")
  EndIf

Return

; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 82
; FirstLine = 66
; Folding = -
; EnableXP